<template>
  <div class="q-pa-md">
    <div class="order-subtitle q-px-lg">
      <h5 class="text-h5">Billing info</h5>
      <q-separator />
    </div>
    <div class="row q-py-lg justify-center q-px-lg">
      <q-btn
        class="q-mx-md text-primary"
        @click="payByCard()"
        size="30px"
        :class="isCardPaySelected ? 'bg-grey-3' : ''"
        :style="isCardPaySelected ? 'transform: scale(0.95);' : ''"
        outline
        unelevated
        icon="credit_card"
        text-color="primary"
        no-caps
        stack
      >
        <span class="text-subtitle1 text-weight-medium">Card de credit</span>
      </q-btn>
      <q-btn
        @click="payAtArrival"
        class="q-mx-md text-primary"
        :class="isArrivalPaySelected ? 'bg-grey-3' : ''"
        :style="isArrivalPaySelected ? 'transform: scale(0.95);' : ''"
        unelevated
        outline
        icon="money"
        size="30px"
        no-caps
        stack
      >
        <span class="text-subtitle1 text-weight-medium">Plata ramburs</span>
      </q-btn>
    </div>
    <div class="row q-col-gutter-xl">
      <div class="col-xs-12 col-sm-6 col-6">
        <div class="column q-pt-sm q-pb-md q-px-xl">
          <p class="text-subtitle1">Adresa de facturare</p>

          <p class="text-weight-medium">PRENUME</p>
          <q-input dense outlined v-model="details.firstName" />
        </div>
        <div class="column q-pt-sm q-pb-md q-px-xl">
          <p class="text-weight-medium">NUME</p>
          <q-input dense outlined v-model="details.lastName" />
        </div>
        <div class="column q-pt-sm q-pb-md q-px-xl">
          <p class="text-weight-medium">ADRESA</p>
          <q-input autogrow dense outlined v-model="details.address" />
        </div>
        <div class="column q-pt-sm q-pb-md q-px-xl">
          <p class="text-weight-medium">TELEFON</p>
          <q-input autogrow dense outlined v-model="details.phone" />
        </div>
        <div class="column q-pt-sm q-pb-md q-px-xl">
          <p class="text-weight-medium">ORAS</p>
          <q-input dense outlined v-model="details.city" />
        </div>
        <div class="column q-pt-sm q-pb-md q-px-xl">
          <p class="text-weight-medium">JUDET</p>
          <q-input dense outlined v-model="details.state" />
        </div>
        <div class="column q-pt-sm q-pb-md q-px-xl">
          <p class="text-weight-medium">COD POSTAL</p>
          <q-input dense outlined v-model="details.zip" />
        </div>
      </div>
      <div v-if="!isArrivalPaySelected" class="col-xs-12 col-sm-6 col-6">
        <div class="column q-pt-sm q-pb-md q-px-xl">
          <p class="text-subtitle1">Credit card info</p>

          <p class="text-weight-medium">NUMELE DE PE CARD</p>
          <p
            v-if="!details.nameOnCard && details.cardNumber && details.cvv && details.expDate"
            text-color="primary"
          >Inca nu ai completate datele de pe card</p>
          <q-input dense outlined v-model="details.nameOnCard" />
        </div>
        <div class="column q-pt-sm q-pb-md q-px-xl">
          <p class="text-weight-medium">NUMARUL CARDULUI</p>
          <q-input dense outlined v-model="details.cardNumber" mask="#### - #### - #### - ####" />
        </div>
        <div class="row q-col-gutter-sm q-px-xl">
          <div class="column col-xs-6 q-pt-sm q-pb-md">
            <p class="text-weight-medium">NUMARUL CVV</p>
            <q-input dense outlined v-model="details.cvv" mask="###" fill-mask />
          </div>
          <div class="column col-xs-6 q-pt-sm q-pb-md">
            <p class="text-weight-medium">DATA EXP.</p>
            <q-input dense outlined v-model="details.expDate" mask="##/##" fill-mask />
          </div>
        </div>
      </div>
      <div v-if="isArrivalPaySelected" class="col-xs-12 col-sm-6 col-6">
        <div class="column q-pt-sm q-pb-md q-px-xl">
          <p class="text-subtitle1">Informatii plata</p>
          <p>Veti plati contravaloarea produselor in momentul primirii acestora prin cash sau card.</p>
        </div>
      </div>
    </div>
    <div class="column items-center q-my-lg margin-lg">
      <div class="row">
        <q-btn @click="goToReview()" class="q-mb-lg" unelevated color="primary" label="CONTINUA" />
      </div>
      <div class="row">
        <q-btn
          @click="goBack()"
          flat
          no-caps
          style="color: #818078"
          label="Vrei sa te intorci la cos?"
        />
      </div>
    </div>
  </div>
</template>

<script>
import { LocalStorage } from "quasar";

export default {
  name: "billing",
  data() {
    return {
      isCardPaySelected: true,
      isArrivalPaySelected: false,
      details: {
        firstName: "",
        lastName: "",
        address: "",
        city: "",
        state: "",
        zip: "",
        nameOnCard: "",
        phone: "",
        cvv: "",
        expDate: "",
        cardNumber: "",
      },
    };
  },
  beforeMount() {
    if (!LocalStorage.getItem("loggedIn")) {
      this.$router.push("/auth");
    }
  },
  mounted() {
    this.details = { ...this.currentUser };
  },
  computed: {
    currentUser() {
      return LocalStorage.getItem("user");
    },
  },
  methods: {
    goBack() {
      this.$router.push({ name: "cart" });
    },
    goToReview() {
      let valid = true;

      if (
        !this.details.firstName ||
        !this.details.lastName ||
        !this.details.address ||
        !this.details.phone ||
        !this.details.city ||
        !this.details.state ||
        !this.details.zip
      ) {
        valid = false;
        this.$q.notify({
          color: "negative",
          message: "Detalii facturare incomplete",
          icon: "report_problem",
        });
      }

      if (
        this.isCardPaySelected &&
        (!this.details.nameOnCard ||
          !this.details.cvv ||
          !this.details.expDate ||
          !this.details.cardNumber)
      ) {
        valid = false;
        this.$q.notify({
          color: "negative",
          message: "Detalii card incomplete",
          icon: "report_problem",
        });
      }

      if (valid) {
        this.$axios
          .put("/api/auth/update", this.details)
          .then((response) => {
            this.$q.notify({
              message: "Detalii actualizate",
              color: "positive",
            });
            LocalStorage.set("user", response.data);
          })
          .catch(() => {
            this.$q.notify({
              color: "negative",
              message: "Problem",
              icon: "report_problem",
            });
          });

        this.$store.dispatch(
          "adminData/setOnlinePayment",
          this.isCardPaySelected
        );

        this.$router.push({ name: "review" });
      }
    },
    payByCard() {
      this.isArrivalPaySelected = false;
      this.isCardPaySelected = true;
    },
    payAtArrival() {
      this.isArrivalPaySelected = true;
      this.isCardPaySelected = false;
    },
  },
};
</script>
